MainProgram:
   GoSub Initialization
   GoSub MonitorInputs
End
//================================================
//================================================
Initialization:
   Flip On
   DeviceNum = 0
   DevNum = "DeviceNum"
   AddEdit "DeviceNum",249,100,30,0,0,"Enter the device number you want to use and Press Enter"
   data Ports; 0,0,0,0,0,0
   PortA = "PortA" \ PortB = "PortB"
   xyText 160,275,"Port A = ","Times New Roman",8,fs_Bold
   xyText 160,345,"PortB = ","Times New Roman",8,fs_Bold
   AddEdit PortA,220,270,50,0,Ports[0],"Enter PortA value and Press Enter"
   AddEdit PortB,220,340,50,0,Ports[0],"Enter PortB value and Press Enter"
   InA = "Read A=>" \ InB = "Read B=>"
   AddButton InA,20,303,70,0,"Read PortA's status and display on the LEDs"
   AddButton InB,20,378,70,0,"Read PortB's status and display on the LEDs"
   ContB2A = "Continuous B=>A"
   AddButton ContB2A,5,340,0,0,"Read PortB's status and Write it to PortA"
   InstBtn = "Instructions"
   AddButton InstBtn,470,100
   GoSub Display_LEDs
   Gosub Display_DllSpecs
   GoSub Display_DeviceSpecs
   GoSub Instructions
Return
//================================================
MonitorInputs:
  while true
      readmouse x,y,mb
      if mb == 1
          if within(x,DX,DX+W*8+8) && within(y,DY,DY+W)
             X = 7-(x-DX)/(W+1)
             if !((Ports[0]>> X)&1)
                 Ports[0] = SetBit(Ports[0],X)
             else
                 Ports[0] = ClrBit(Ports[0],X)
             endif
             Gosub Display_LEDs
          endif
          if within(x,DX,DX+W*8+8) && within(y,DY+W+45,DY+W*2+45)
             X = 7-(x-DX)/(W+1)
             if !((Ports[1]>> X)&1)
                 Ports[1] = SetBit(Ports[1],X)
             else
                 Ports[1] = ClrBit(Ports[1],X)
             endif
             Gosub Display_LEDs
          endif
          waitnokey 250
      endif
      if !EditHasFocus(DevNum)
        if EditChanged(DevNum)
           m = GetEdit(DevNum)
           DeviceNum = 0
           if IsNumber(m) then DeviceNum = Limit(ToNumber(m),0,20)
           SetEdit DevNum,DeviceNum
           Gosub Display_DeviceSpecs
           GoSub Display_LEDs
        endif
      endif
      if !EditHasFocus(PortA)
        if EditChanged(PortA)
           m = GetEdit(PortA)
           Ports[0] = 0
           if IsNumber(m) then Ports[0] = Limit(ToNumber(m),0,255)
           GoSub Display_LEDs \  GoSub UpdatePorts
        endif
      endif
      if !EditHasFocus(PortB)
        if EditChanged(PortB)
           m = GetEdit(PortB)
           Ports[1] = 0
           if IsNumber(m) then Ports[1] = Limit(ToNumber(m),0,255)
           GoSub Display_LEDs \  GoSub UpdatePorts
        endif
      endif
      GetButton btn
      if btn == InA
         if Ports[4]
            Ports[4] = 0
            n=usbm_DirectionA(DeviceNum,0,255)
            n = usbm_WriteA(DeviceNum,255)
         endif
         Ports[0] = usbm_ReadA(DeviceNum)
         Ports[2] = Ports[0]
         GoSub Display_LEDs
      elseif btn == InB
         if Ports[5]
            Ports[5] = 0
            n=usbm_DirectionB(DeviceNum,0,255)
            n = usbm_WriteB(DeviceNum,255)
         endif
         Ports[1] = usbm_ReadB(DeviceNum)
         Ports[3] = Ports[1]
         GoSub Display_LEDs
      elseif btn == ContB2A
         GoSub ContinuousIO_InB_OutA
      elseif btn == InstBtn
         n = MsgBox(I_M)
      endif
  wend
Return
//================================================
Display_LEDs:
   SetEdit PortA,Ports[0]
   SetEdit PortB,Ports[1]
   DX = 100 \ DY = 300 \ W = 30
   for k = 0 to 1
      for i=7 to 0
          c = black \ cc = 0
          m = DX+i*(W+1) \ mm = DY+k*(W+45)
          if Ports[k] & 2^(7-i) then cc = 1 \c = red
          Circlewh m,mm,W,W,c,c
          SetColor white,c \ xyText m+12,mm+7,cc,"Times New Roman",8
      next
   next
   SetColor black,white
   FLip
Return
//================================================
Display_DllSpecs:
    xyText 20,0,"USB Micro DLL Data","Times New Roman",15,fs_Bold|fs_Underlined
    m = usbm_DLLSpecs()
    xyText 10,30,Extract(m,"|",1),"Times New Roman",10
    xyText 10,45,Extract(m,"|",2),"Times New Roman",10
    xyText 10,60,"Version#:"+Extract(m,"|",4)+":"+Extract(m,"|",3),"Times New Roman",10
    FLip
Return
//================================================
Display_DeviceSpecs:
    RectangleWH 0,75,230,120,white,white
    n = usbm_finddevices()
    n = usbm_numberofdevices()
    m = ""
    if n != 1 then m = "s"
    xyText 10,79, spaces(20)+"Found "+n+" Device"+m,"Times New Roman",10,fs_Bold
    xyText 210,105,"Device:","Time New Roman",8
    xyText 20,95,"Device Specifications","Times New Roman",15,fs_Bold|fs_Underlined
    mConstant Ports,0
    if usbm_DeviceValid(DeviceNum)
        n = usbm_initports(DeviceNum)
        n = usbm_DirectionA(DeviceNum,0,255)
        n = usbm_WriteA(DeviceNum,255)
        n = usbm_DirectionB(DeviceNum,0,255)
        n = usbm_WriteB(DeviceNum,255)
        m = usbm_DeviceSpecs(DeviceNum)
        VID = "Made By:"+hex(tonumber(extract(m,"|",3)))+":"
        MFR = VID+extract(m,"|",4)
        PID = "Device:"+hex(tonumber(extract(m,"|",2)))+":"
        PRD = PID+extract(m,"|",5)
        DID = "Version:"+hex(tonumber(extract(m,"|",1)))
        SER = "S/N:"+extract(m,"|",6)
    else
        MFR = "Made By:" \ PRD = "Device:"\ DID = "" \ SER = "S/N:"
    endif
    xyText 10,125,MFR,"Times New Roman",10
    xyText 10,140,PRD+spaces(20)+DID,"Times New Roman",10
    xyText 10,155,SER,"Times New Roman",10
    FLip
Return
//================================================
UpdatePorts:
   if Ports[0] != Ports[2]
      Ports[2] = Ports[0]
      if !Ports[4]
         Ports[4] = 1
         n = usbm_directionA(DeviceNum,255,255)
      endif
      n = usbm_WriteA(DeviceNum,Ports[0])
   endif
   if Ports[1] != Ports[3]
      Ports[3] = Ports[1]
      if !Ports[5]
         Ports[5] = 1
         n = usbm_directionB(DeviceNum,255,255)
      endif
      n = usbm_WriteB(DeviceNum,Ports[1])
   endif
Return
//================================================
ContinuousIO_InB_OutA:
  if !vType(CIO_FT)
     CIO_FT = 0
     data IM;ProgName()
     data IM;"This option will READ IN Port B and then OUTPUT the"
     data IM;"value to Port A...Continously.",""
     data IM;"To stop the action press the 'Stop b=>' button once"
     data IM;"started.",""
     data IM;"The LEDs will be updated according to the values on"
     data IM;"the ports....BUT....you won't be able to change"
     data IM;"the value fields or click on the LEDs in this mode.",""
     data IM;"             Are you sure you want to continue?"
  endif
  If !MsgBox(IM) then return
  if usbm_DeviceValid(DeviceNum)
     n = usbm_directionb(DeviceNum,0,255)
     n = usbm_writeb(DeviceNum,255)
     n = usbm_directiona(DeviceNum,255,255)
     RemoveButton ContB2A
     AddButton "Stop B=>A",5,340
     while true
        GetButton btn
        if btn == "Stop B=>A" then break
        m = usbm_readb(DeviceNum)
        n = usbm_writea(DeviceNum,m)
        Ports[0] = m
        Ports[1] = m
        GoSub Display_LEDs
     wend
     RemoveButton "Stop B=>A"
     AddButton ContB2A,5,340
  endif
Return
//================================================
Instructions:
    data I_M;ProgName()
    data I_M;"This program demonstrates some of the features of the USB_Micro"
    data I_M;"USB I/O device.",""
    data I_M;"If you have devices connected you can select which one you want to"
    data I_M;"access by typing in the value in the Edit box labeled 'Device'.",""
    data I_M;"If when you started the program you had no devices connected and then"
    data I_M;"you connected one then just type its number in the box to see if it"
    data I_M;"is available and also the number of found devices will be updated and"
    data I_M;"displayed at the bottom of the DLL information area.",""
    data I_M;"You can press the 'Read A=>' or 'Read B=>' buttons to read the port"
    data I_M;"and display its value on the LEDs and in the Value box.",""
    data I_M;"You can click on individual LEDs or tyoe a value (decimal) inside the"
    data I_M;"value box. This action will output the value to the Port.",""
    data I_M;"The 'Continuous B=>A' button causes a CONTINOUOS reading of PortB "
    data I_M;"and outputting its value to PortA. Once this option is selected, you "
    data I_M;"won't be able to press other buttons or click on the LEDs. If you"
    data I_M;"enter data in the values fields they won't remain. To get out of this"
    data I_M;"mode press the 'Stop B=>A' button.",""
    data I_M;"To test the actions connect the pins of PortA and B to appropriate"
    data I_M;"buttons or LEDs to see how the actions affect the real life ports.",""
Return
//================================================
