MainProgram:
    GoSub Initialization
    GoSub MonitorInputs
End
//================================================
//================================================
Initialization:
   LED_Pin = 5 \ Thermo_Pin = 4 \ PB_Pin = 6
   OldTc =-1000
   Flip On
   DeviceNum = 0
   ShowFarenhite = false \ ShowCelsius = true
   xyText 50,530,"Show Temperature On LCD","",12,fs_Bold|fs_underlined
   xyText 90,555,"Celsius"
   xyText 90,573,"Fahrenhite"
   DevNum = "DeviceNum" \ LCDText = "LCDText" \ LCDData = "LCDData" \ LCDCmd = "LCDCmd"
   AddEdit DevNum,249,100,30,0,0,"Enter the device number you want to use and Press Enter"
   AddEdit LCDText,160,430,200,0,"Testing","Enter text to display on the LCD"
   AddEdit LCDCmd,160,460,50,0,"01","Enter the LCD command in hex"
   AddEdit LCDData,160,490,50,0,"00","Enter the LCD data in hex"
   InstBtn = "Instructions" \ InitLCDBtn = "Init LCD" \ SndTxtBtn = "Send Text To LCD"
   SndCmdBtn = "Send LCD Command" \ SndDataBtn = "Send Data To LCD"
   data Buttons;InstBtn      ,470,100,0,0,""
   data Buttons;InitLCDBtn   ,190,360,100,60,"Initialize the LCD"
   data Buttons;SndTxtBtn    ,10,430,135,0,"Send the Text String to the LCD"
   data Buttons;SndCmdBtn    ,10,460,135,0,"Send the Command byte to the LCD"
   data Buttons;SndDataBtn   ,10,490,135,0,"Send The Data byte to the LCD"
   for n=0 to MaxDim(Buttons,1)-1 step 6
      AddButton Buttons[n],Buttons[n+1],Buttons[n+2],Buttons[n+3],Buttons[n+4],Buttons[n+5]
   next
   Setcolor white,Black
   xyText 90,300," Temperature Data ","Times New Romand",15,fs_Bold
   setcolor black,white
   Gosub Display_DllSpecs
   GoSub Display_DeviceSpecs
   GoSub Display_ThermoSpecs
   GoSub Init_LCD
   GoSub Instructions
Return
//================================================
MonitorInputs:
  b = 1 \ ttt=0
  while true
      n = usbm_WriteABit(DeviceNum,255-2^LED_Pin,2^LED_Pin*b) \ b = !b
      GoSub Display_Temperature
      GoSub Check_PushButton
      readmouse mx,my,mb
      if mb == 1
          if within(mx,70,85) && within(my,555,570)
             ShowCelsius = true \ ShowFarenhite = false \ OldTc = -1000
          elseif within(mx,70,85) && within(my,573,588)
             ShowCelsius = false \ ShowFarenhite = true \ OldTc = -1000
          endif
      endif
      if !EditHasFocus(DevNum)
        if EditChanged(DevNum)
           m = GetEdit(DevNum)
           DeviceNum = 0
           if IsNumber(m) then DeviceNum = Limit(ToNumber(m),0,20)
           SetEdit DevNum,DeviceNum
           Gosub Display_DeviceSpecs
           GoSub Display_ThermoSpecs
           GoSub Init_LCD
        endif
      endif
      GetButton btn
      if btn == InstBtn
         n = MsgBox(I_M)
      elseif btn == InitLCDBtn
          GoSub Init_LCD
          ShowFarenhite = false \ ShowCelsius = false 
      elseif btn == SndTxtBtn
          t = GetEdit(LCDText)
          n = usbm_LCDCmd( 0, 0x1)  //clear
          GoSub Write_LCD
          ShowFarenhite = false \ ShowCelsius = false 
      elseif btn == SndCmdBtn
          n = HexToInt("0x"+GetEdit(LCDCmd))
          if !IsNumber(n) then n = 0
          n = usbm_LCDCmd(0,n )
          ShowFarenhite = false \ ShowCelsius = false 
      elseif btn == SndDataBtn
          n = HexToInt("0x"+GetEdit(LCDData))
          if !IsNumber(n) then n = 0
          n = usbm_LCDData(0,n )
          ShowFarenhite = false \ ShowCelsius = false 
      endif
      if ShowCelsius 
         CircleWH 70,555,15,15,black,black
         CircleWH 70,573,15,15,black,white
      elseif ShowFarenhite
         CircleWH 70,555,15,15,black,white
         CircleWH 70,573,15,15,black,black
      else
         CircleWH 70,555,15,15,black,white
         CircleWH 70,573,15,15,black,white
      endif
  wend
Return
//================================================
Display_DllSpecs:
    xyText 20,0,"USB Micro DLL Data","Times New Roman",15,fs_Bold|fs_Underlined
    m = usbm_DLLSpecs()
    xyText 10,30,Extract(m,"|",1),"Times New Roman",10
    xyText 10,45,Extract(m,"|",2),"Times New Roman",10
    xyText 10,60,"Version#:"+Extract(m,"|",4)+":"+Extract(m,"|",3),"Times New Roman",10
    FLip
Return
//================================================
Display_DeviceSpecs:
    RectangleWH 0,75,230,120,white,white
    n = usbm_finddevices()
    n = usbm_numberofdevices()
    m = ""
    if n != 1 then m = "s"
    xyText 10,79, spaces(20)+"Found "+n+" Device"+m,"Times New Roman",10,fs_Bold
    xyText 210,105,"Device:","Time New Roman",8
    xyText 20,95,"Device Specifications","Times New Roman",15,fs_Bold|fs_Underlined
    if usbm_DeviceValid(DeviceNum)
        n = usbm_initports(DeviceNum)
        n = usbm_DirectionA(DeviceNum,255-2^PB_Pin,255)
        n = usbm_SetBit(DeviceNum,PB_Pin)
        n = usbm_DirectionB(DeviceNum,255,255)     
        m = usbm_DeviceSpecs(DeviceNum)        
        VID = "Made By:"+hex(tonumber(extract(m,"|",3)))+":"
        MFR = VID+extract(m,"|",4)
        PID = "Device:"+hex(tonumber(extract(m,"|",2)))+":"
        PRD = PID+extract(m,"|",5)
        DID = "Version:"+hex(tonumber(extract(m,"|",1)))
        SER = "S/N:"+extract(m,"|",6)
    else
        MFR = "Made By:" \ PRD = "Device:"\ DID = "" \ SER = "S/N:"
    endif
    xyText 10,125,MFR,"Times New Roman",10
    xyText 10,140,PRD+spaces(20)+DID,"Times New Roman",10
    xyText 10,155,SER,"Times New Roman",10
    FLip
Return
//================================================
Display_ThermoSpecs:
    if usbm_DeviceValid(DeviceNum)
        n = usbm_reset1wire(DeviceNum,4)
        n = usbm_write1wire(DeviceNum,0x33)
        Fam = hex(usbm_read1wire(DeviceNum))
        Ser = ""
        for i=1 to 6
           Ser = Ser+hex(usbm_read1wire(DeviceNum))+"-"
        next
        Ser = Left(Ser,Length(Ser)-1)
        CRC = hex(usbm_read1wire(DeviceNum))
    else
        Fam = "-" \ Ser = "-" \ CRC = "-"
    endif
    RectangleWH 0,230,230,50,white,white
    xyText 20,200,"ds1820 Thermometer Chip","Time New Roman",15,fs_Bold|fs_UnderLined
    xyText 10,230,"Family:","",10,fs_Bold \ xyText -1,-1,Fam,"Times New Roman",10
    xyText 10,245,"S/N   :","",10,fs_Bold \ xyText -1,-1,Ser,"Times New Roman",10
    xyText 10,260,"CRC   :","",10,fs_Bold \ xyText -1,-1,CRC,"Times New Roman",10
    flip
Return
//=========================================================
Init_LCD:
     if !usbm_DeviceValid(DeviceNum) then return
     n = usbm_InitLCD(DeviceNum, 0x12, 0x13)     
     n = usbm_SetBit(DeviceNum, 0)   \ delay 20
     n = usbm_ResetBit(DeviceNum, 0) \ delay 100
     n = usbm_SetBit(DeviceNum, 0)   \ delay 100
     n = usbm_LCDCmd(DeviceNum, 0x1C)
     n = usbm_LCDCmd(DeviceNum, 0x14)
     n = usbm_LCDCmd(DeviceNum, 0x28)
     n = usbm_LCDCmd(DeviceNum, 0x4F)
     n = usbm_LCDCmd(DeviceNum, 0xE0)
     n = usbm_LCDCmd(DeviceNum, 0x1)
Return
//=========================================================
Write_LCD: //t is the string to write
   n = usbm_LCDCmd( 0, 0x2)  //reset cursor to beginning
   for a = 1 To Length(t)    
       n = usbm_LCDData( 0, ArrayStr(t,a))
   next
Return
//=========================================================
Read_ThermoData:
   if !usbm_DeviceValid(DeviceNum) then Tc = -40 \ Tf = -40 \return
   n = usbm_reset1wire(DeviceNum,Thermo_Pin)
   n = usbm_write1wire(DeviceNum,0xCC)
   n = usbm_write1wire(DeviceNum,0x44)
   n = usbm_reset1wire(DeviceNum,Thermo_Pin)
   n = usbm_write1wire(DeviceNum,0xCC)
   n = usbm_write1wire(DeviceNum,0xBE)
   n = usbm_read1wire(DeviceNum)
   m = (usbm_read1wire(DeviceNum) & 7) << 8
   Tc = (m+n)/16.0
   Tf = Tc*1.8+32
Return
//=========================================================
Display_Temperature:
   GoSub Read_ThermoData
   setcolor Black,Gray
   xytext 20,324,Center(Format(Tc,"000.00C = ")+format(Tf,"000.00F")," ",21),"",20,fs_Bold
   setcolor Black,white
   flip
   if (ShowCelsius || ShowFarenhite) 
      if ShowCelsius
         t = "Temp = "+Format(Tc,"#0.00C       ")
      elseif ShowFarenhite
         t = "Temp = "+Format(Tf,"#0.00F       ")
      endif
      if OldTc != Tc then GoSub Write_LCD \ OldTc = Tc
   endif
Return
//=========================================================
Check_PushButton:
    if !usbm_DeviceValid(DeviceNum) then return
    n = usbm_ReadA(DeviceNum) & (2^PB_Pin)
    if !n 
        ShowCelsius = !ShowCelsius \ ShowFarenhite = !ShowCelsius 
        OldTc = -1000
        delay 200
    endif
Return
//=========================================================
Instructions:
    data I_M;ProgName()
    data I_M;"This program demonstrates some of the features of the USB_Micro USB I/O device.",""
    data I_M;"If you have devices connected you can select which one you want to"
    data I_M;"access by typing in the value in the Edit box labeled 'Device'.",""
    data I_M;"If when you started the program you had no devices connected and then"
    data I_M;"you connected one then just type its number in the box to see if it"
    data I_M;"is available and also the number of found devices will be updated and"
    data I_M;"displayed at the bottom of the DLL information area.",""
    data I_M;"This application shows various aspects:"
    data I_M;"    -Pin Input"
    data I_M;"    -Pin Output"
    data I_M;"    -1Wire serial data communications"
    data I_M;"    -LCD control",""
    data I_M;"You should connect the LCD lines as follows:"
    data I_M;"   Reset = A0,  RS = A2,  RW = A1,  E = A3, D0-7 to B0-7",""
    data I_M;"Also connect A5 to an LED and A6 to a Push Button.",""
    data I_M;"Also Connect A4 to the Data line of the ds1820 thermometer chip.","",""
    data I_M;"The application will read the temperature information from the ds1820"
    data I_M;"and convert it and then display it on the screen in both Fahrenheit and"
    data I_M;"Celsius. Also the C is displayed on the LCD by default but you can change this.",""
    data I_M;"You can select between the C or F by clicking on the screen radio button to"
    data I_M;"select either one. Also you can do the same thing by pressing the push button"
    data I_M;"connected as described above. This button will act as a toggle and keep switching"
    data I_M;"between the two scales as long as it is pushed.",""
    data I_M;"The application will also keep blinking the LED connected as above.",""
    data I_M;"Any time you can reinitialize the LCD or send to it a command byte or a "
    data I_M;"data byte or a whole string. If you do so the temperature will no longer be"
    data I_M;"displayed on the LCD. To make it display again either press the push button or"
    data I_M;"click the mouse on one of the radio buttons on the screen.",""
Return
//================================================
