
//---------------------------------------------------------------------------
//
// CircuitGizmos RobotBASIC example code
//
// Author:           Robert Severson
//
// File:             cgrbdemo1.bas
//
// Creation Date:    2009-02-06
//
// Copyright:        Copyright (C), Robert R. Severson 2009. All rights
//                   reserved. Created in the year 2009 as an unpublished
//                   copyright work. This program and the information
//                   contained in it is property of Robert R. Severson
//                   and may not be used, copied, or reproduced without
//                   prior written permission of Robert R. Severson
//
//                   This software remains the property of Robert R.
//                   Severson and is supplied under licence only. The use
//                   of this software is permitted under the terms of that
//                   licence only.
//
//                   RobotBASIC may be used in accordance with the terms of
//                   the License Agreement. Please read the terms carefully
//                   and make sure that you accept them ALL before you use
//                   the system.
//
//                   The book "Robot Programmer's Bonanza"  (ISBN 978-0-07-154797-0)
//                   published by The McGraw-Hill Companies, Inc. is a great
//                   resource for learning about the robot simulator and the
//                   language. Please visit www.RobotBASIC.com for more details
//                   and to obtain the latest updates, demos, additional book
//                   titles and other information.
//
//                   Write us at RobotBASIC@yahoo.com for information on
//                   seminars relating to the use of the language and simulator.
//                   A list of topics can be found on the web site.
//
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
// Main Program
//
//---------------------------------------------------------------------------

MainProgram:

    // Allow screen double buffering
    Flip On


    //---------------------------
    // Get information for DLL
    //---------------------------

    xyText 5, 20, "USBmicro DLL Data", "Verdana", 15, fs_Bold|fs_Underlined

    m = usbm_DLLSpecs()


    //---------------------------
    // Display discovered information
    //---------------------------

    // About this DLL
    xyText 25, 60, "About:" + Extract(m,"|",1), "Verdana", 10
    
    // DLL Version and Date
    xyText 25, 80, "DLL Version: " + Extract(m,"|",4), "Verdana", 10
    xyText 25, 100, "DLL Version date: " + Extract(m,"|",3), "Verdana", 10


    //---------------------------
    // Get information about 
    // connected devices.
    //---------------------------

    // Discover the devices
    n = usbm_finddevices()

    // Count devices 
    n = usbm_numberofdevices()
    m = ""
    if n != 1 then m = "s"
    xyText 5, 150, "Found " + n + " Device" + m, "Verdana", 10


    // Display devices
    xyText 5, 180, "Device", "Verdana", 10, fs_Bold|fs_Underlined
    xyText 80, 180, "Made By", "Verdana", 10, fs_Bold|fs_Underlined
    xyText 220, 180, "Type", "Verdana", 10, fs_Bold|fs_Underlined
    xyText 300, 180, "Serial Number", "Verdana", 10, fs_Bold|fs_Underlined

    // Loop through all of the devices
    for loop = 1 to n

        // Get device info
        m = usbm_DeviceSpecs(loop - 1)

        // Print device info
        xyText 5, 190 + (20 * loop), loop, "Verdana", 10
        xyText 80, 190 + (20 * loop), extract(m,"|",4), "Verdana", 10
        xyText 220, 190 + (20 * loop), extract(m,"|",5), "Verdana", 10
        xyText 300, 190 + (20 * loop), extract(m,"|",6), "Verdana", 10

    next loop

    // Show buffered screen
    flip

    Waitkey " ", n

End
